#include <qptrlist.h>

#include "kadu.h"

#include "osd_widget.h"

/**

	based on hints module

**/

class OSDManager : public QObject
{
	Q_OBJECT
	
	public:
		OSDManager();
		~OSDManager();
		
	
	public slots:
	
		void deleteAll(void);
		
/*********** sloty dla notify ************/
		/* nowa rozmowa */
		void newChat(const UinsList &senders, const QString& msg, time_t time);

		/* nowa wiadomo w oknie chat */
		void newMessage(const UinsList &senders, const QString& msg, time_t time, bool &grab);

		/* bd poczenia */
		void connectionError(const QString &message);

		/* uytkownik zmieni status na "Dostpny" */
		void userChangedStatusToAvailable(const UserListElement &ule);

		/* uytkownik zmieni status na "Zaraz wracam" */
		void userChangedStatusToBusy(const UserListElement &ule);

		/* uytkownik zmieni status na "Niewidoczny" */
		void userChangedStatusToInvisible(const UserListElement &ule);

		/* uytkownik zmieni status na "Niewidoczny" lub "Niedostpny" */
		void userChangedStatusToNotAvailable(const UserListElement &ule);

		/* inna informacja do powiadomienia */
		/* jeeli parameters == NULL, to brane s domylne ustawienia dymkw typu message
		 * w przeciwnym razie z mapy brane s nastpujce wartoci:
		 *		"Pixmap"		- QPixmap
		 *		"Font"			- QFont
		 *		"Foreground color"	- QColor
		 *		"Background color"	- QColor
		 *		"Timeout"		- unsigned int	0 - cay czas, ale to raczej bez sensu ;)
		 *		"Translucency"		- bool
		 *		"Translucency level"	- unsigned int	<=100
		 *		"X"			- unsigned int	wsprzdna
		 *		"Y"			- unsigned int	wsprzdna
		 * jeeli ktra z wartoci jest nieokrelona, to dla niej brana jest warto domylna
		 * gdy UserListElement != NULL, to jego uin brany jest do tworzenia dymka (LMB np otwiera okno rozmowy z danym uinem)
		*/
		void message(const QString &from, const QString &message, const QMap<QString, QVariant> *parameters, const UserListElement *ule);
/*********** koniec slotw dla notify *************/

	private:
		QPtrList<OSDWidget> widgets;
		int height;
		
		void addOSD(const QString &text, const QPixmap &pixmap, const QFont &font, const QColor &fgcolor, const QColor &bgcolor, unsigned int timeout, bool translucency, double translucency_level, int x, int y, const UinsList &senders = NULL);
	
	private slots:
		void timeout(unsigned int id, bool chat);
};
