#include "osd_manager.h"

class OSDProperties
{
	public:
		QFont font;
		QColor fgcolor;
		QColor bgcolor;
		unsigned int timeout;
		bool def_colors;
		QString icon;
};

class OSD_Notify : public QObject
{
	Q_OBJECT
	
	public:
		OSD_Notify();
		~OSD_Notify();
		
	private:
		OSDManager *osd_manager;
		OSDPreviewWidget *preview;
		
		QStringList config_opts_prefixes;
		QString currentOptionPrefix;
		QMap<QString, OSDProperties> config_hint_properties;
	
		void createGUI(void);
		void destroyGUI(void);
		
	private slots:
		void onCreateConfigDialog(void);
		void onApplyConfigDialog(void);
		void tabIn(void);
		void tabOut(void);
		void changeUseTrans(bool);
		
		void preview_positionChanged(unsigned int, unsigned int);
		
		
		void toggled_SetAll(bool);
		void clicked_HintType(int id);
		void clicked_ChangeFont(const char *, const QFont&);
		void clicked_ChangeBgColor(const char *, const QColor &);
		void clicked_ChangeFgColor(const char *, const QColor &);
		void clicked_ChooseIcon(void);
		void changed_Timeout(int);
		void toggled_UseDefColors(bool);
		void changed_PathToIcon( const QString & );
		void toggled_ShowContent(bool);
		void toggled_CustomSyntax_chat(bool);
		void toggled_CustomSyntax_status(bool);
		void toggled_ShowPhoto_chat(bool toggled);
		void toggled_ShowPhoto_status(bool toggled);
		void clicked_NewGoes(int);
		void clicked_ForCorner(int);
};
